/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <windows.h>
#include "resource.h"
#include "nSX2.h"

BOOL CALLBACK AboutDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
    char Str[100] ; 
    
    switch(Message)
    {
        case WM_INITDIALOG:
           SendDlgItemMessage(hwnd, IDC_ABOUT_LOGO, STM_SETIMAGE, IMAGE_BITMAP, 
                (LPARAM)LoadImage (GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_ABOUT_LOGO), 
                            IMAGE_BITMAP, 0, 0, 0));
           sprintf( Str, "Version %d.%d.%d", nSX2_VERSION_MAJ, nSX2_VERSION_MIN, nSX2_VERSION_BUILD) ;                 
           SetDlgItemText( hwnd, IDC_ABOUT_VERSION, Str) ;
           ReadSentences ( hwnd );
                          
        return TRUE;
        
        case WM_CLOSE:
              EndDialog(hwnd, IDOK);  
        break;
        
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDOK:
                    EndDialog(hwnd, IDOK);
                break;
            }
        break;
        default:
            return FALSE;
    }
    return TRUE;
}

void OpenAboutDialog(HWND hwnd) 
{
    DialogBox(GetModuleHandle(NULL), 
                     MAKEINTRESOURCE(IDD_ABOUT), hwnd, AboutDlgProc);
}

/***************************************************************************/
/* READ SENTENCES   				    							       */	
/***************************************************************************/


ReadSentences ( HWND hwnd )
{
    int Max = 1; // total of lines
    int RandNumber; // random number
   	char tempText[MAX_PATH];  
   	int ch;
   	FILE * fp;
   	
   	sprintf(tempText,"%s\\Sentences.txt",cCurDir);  

    /* OPEN FILE */
    fp = fopen(tempText,"rb"); 
     
    if (fp == NULL) {
        
    	SetDlgItemText( hwnd, IDC_ABOUT_RUNSTRING, "Error opening file") ;
    	
    } else { // If no error
    	
        /* GET TOTAL OF LINES */
        while ((ch=fgetc(fp)) != EOF) {
                if (ch == 10) { Max++; } // "ch == 10" = \n
        }
 
        /* GET A RANDOM NUMBER */
        srand ( time(NULL) );
        RandNumber = rand()%Max+1; //random number between 1 an Max, see this: http://www.cplusplus.com/ref/cstdlib/rand.html
    	
    	/* GET TEXT FROM FILE */
        rewind(fp); // Backs to start of the file
        
        sprintf(tempText, ""); // clear tempText   <-------------
        Max = 0; // "reset" Max
        
        while ((ch=fgetc(fp)) != EOF) {

                if (ch == 10) { Max++; } // "ch == 10" = \n
                else {
                          if (Max == RandNumber -1) {
                                sprintf(tempText,"%s%c",tempText,ch); // adds to tempText
                          }
                          
                          if (Max == RandNumber) {
                          
                                break;
                          
                          }
                 }
                
        }
        
        /* PRINT RESULT */
        SetDlgItemText( hwnd, IDC_ABOUT_RUNSTRING, tempText) ;
        
    	/* CLOSE FILE */
    	fclose(fp);

    }
}
