/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include "nSX2.h"
#include "PS2Edefs.h"

#include "timers.h"

#include "IntrC.h"

 

void TIMERS_TestOverlow ( _u8 fTimer ) {
	/* if Flag Overflow is Enable */
	if ( GET_MODE_OVFE_TIMER( fTimer ) == 0x1 ) {
		/* if Count value > compare value */
		if ( Timer[ fTimer ].Reg->count > Timer[ fTimer ].Reg->comp ) {
			/* Set the Overflow Flag */
			SET_MODE_OVFF_TIMER( fTimer );
		
			/* Raise an interrupt, only for Timer 0 & 1*/
			switch ( fTimer ) {
				case 0 : INTC_RaiseIntByCause ( INTC_TIM0 );break;	//... for timer 0
				case 1 : INTC_RaiseIntByCause ( INTC_TIM1 );break;	//... for timer 1
			}
				
		}
	}

}


void TIMERS_TestEqual ( _u8 fTimer ) {
	/* if Flag Equal is Enable */
	if ( GET_MODE_CMPE_TIMER( fTimer ) == 0x1 ) {
		/* if Cont value >= Compare Value */
		if ( Timer[ fTimer ].Reg->count >= Timer[ fTimer ].Reg->comp ) {
			/* set the Equal Flag */
			SET_MODE_EQUF_TIMER( fTimer );

			/* Raise an interrupt, only for Timer 0 & 1*/
			switch ( fTimer ) {
				case 0 : INTC_RaiseIntByCause ( INTC_TIM0 );break;	//... for timer 0
				case 1 : INTC_RaiseIntByCause ( INTC_TIM1 );break;	//... for timer 1
			}
		}
	}

}



void TIMERS_TestZeroReturn ( _u8 fTimer ) {
	/* if Flag Zero Return is Enable */
	if ( GET_MODE_ZRET_TIMER( fTimer ) == 0x1 ) {
		/* if Overflow or Equal Flag is set */
		if ( (GET_MODE_EQUF_TIMER( fTimer) == 0x1) || (GET_MODE_OVFF_TIMER( fTimer) == 0x1) ) {
			/* Reset the Count value */
			Timer[ fTimer ].Reg->count = 0;

		}

	}

}




