/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include "nSX2.h"
#include "PS2Edefs.h"

#include "TIMERS.h"

void TIMERS_PS2_Update ( _u8 fTimer ) {

	_u64	ElapsedCycles;


	/* if the PS2 Timer is running */
	if ( GET_MODE_CUE_TIMER( fTimer ) == 0x1 ) {
		

		/* if the PS2 Clock Selection is different of H-BLNK */
		if ( GET_MODE_CLKS_TIMER( fTimer ) != 0x3 ) {

			/* Get the number of cycles since last call */	
			ElapsedCycles = MipsCpu.Nb_Cycles - TIMERS_PreviousCycles;

			/* Update the count value of the Timer */
			switch ( GET_MODE_CLKS_TIMER( fTimer ) ) {
		
				case 0:	//BUSCLOCK
					Timer[ fTimer ].Reg->count = (_u32) ( Timer[ fTimer ].Reg->count + (_u32)( ElapsedCycles / 2 )); break;
				break;

				case 1:	//BUSCLOCK/16
					Timer[ fTimer ].Reg->count = (_u32) ( Timer[ fTimer ].Reg->count + (_u32)( ElapsedCycles / 32 )); break;
				break;

				case 2:	//BUSCLOCK/256
					Timer[ fTimer ].Reg->count = (_u32) ( Timer[ fTimer ].Reg->count + (_u32)( ElapsedCycles / 512 )); break;
				break;


			}





			/* Performs Test on Overflow,Equal, ZEroReturn */
			TIMERS_TestOverlow 		( fTimer );
			TIMERS_TestEqual 		( fTimer );
			TIMERS_TestZeroReturn 	( fTimer );

		}/* end of if the PS2 Clock Selection is different of H-BLNK */

	}/* end of if the PS2 Timer is running */

}

