/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include <math.h>
#include <string.h>


#include "nSX2.h"
#include "PS2Edefs.h"

#include "VU.h"
#include "VU1_micromode_tables.h"

#include "VIF.h"


VPUDataDecompresionUnit	VIF[2];



void VIF_Log ( char * ftext  , ...   ) {
	char VIF_LogText[ FILE_NAME_LENGHT ];

	if ( debug_vif == 1 ) {

	    va_list ap;
   		va_start (ap, ftext);
    	vsprintf (VIF_LogText, ftext, ap);
    	va_end (ap);

		sprintf(VIF_LogText,"%s\n",VIF_LogText);
		//PrintToEmuOutput (  VIF_LogText ); 

		PrintToVIFOutput 		(  VIF_LogText );
	}

}
 

/* VIF Controller Initialisation */
void	VIF_Init( void ) {

#ifdef EMU_LOG
	EMU_LOG("[VIF]Initialisation");
#endif

	/* Emulator Initialisation */
	VIF[ VIF0 ].Reg = ( VIFRegisters * ) &SpecialAreaMemory[   ( VIF0_STAT_REG & 0xFFFF )  ];

	VIF[ VIF0 ].iBitInterruptEnable 		= TRUE;
	VIF[ VIF0 ].IgnoreMismatchDmaTAGError	= FALSE;
	VIF[ VIF0 ].IgnoreVIFCodeError			= FALSE;


	VIF[ VIF1 ].Reg = ( VIFRegisters * ) &SpecialAreaMemory[   ( VIF1_STAT_REG & 0xFFFF )  ];

	VIF[ VIF1 ].iBitInterruptEnable 		= TRUE;
	VIF[ VIF1 ].IgnoreMismatchDmaTAGError	= FALSE;
	VIF[ VIF1 ].IgnoreVIFCodeError			= FALSE;




}












