/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"
 
#include "r5900_main.h"

#include "VU_opcodes.h"

#include "VU0_micromode_tables.h"

//#include "../PS2Edefs.h"

#include "VU.h"

/* for XTOP opcode */
#include "VIF.h"

#define		VU0GetLowerOp() *( (_u32 *) (( _u8 *)( VectorUnit0.MicroMem + VectorUnit0.PC ) ))
#define		VU0GetUpperOp() *( (_u32 *) (( _u8 *)( VectorUnit0.MicroMem + VectorUnit0.PC + 4 ) ))

extern _u8 debug_vu1;

_u8	debug_VU0 = 0; 
_u32	LowerOp;
_u32	UpperOp;




static VU0_MaxOpcode = 0;
 
  
void VectorUnit0_Execute_OneOpcode(void) {
 	char 		tempText[100];	

	_u32	TestOpcode;


		LowerOp = VU0GetLowerOp();
		UpperOp = VU0GetUpperOp();

		VectorUnit0.PC = VectorUnit0.PC + 8; 		

		if ( ((_u32)UpperOp & (_u32)0x40000000)) {
			VectorUnit0.halt = 1 ;
/*
			if(debug_VU0 == 1 ) {
				PrintToEmuOutput("2----NORMAL TERMINATION-----\n");
				sprintf(tempText,"VU0_PC:%4.4x:", VectorUnit0.PC - 8);PrintToEmuOutput(tempText);
			}
*/
		}

		
		if ( UpperOp & 0x80000000) { /* I flag */ 
	
			VectorUnit0.CCR[ VU_I_REGISTER ] = (_u32)LowerOp;

		} else {
			/* first upper */ 
			MipsCpu.vuOpcode = UpperOp;
			COP2_MI_VU0_UPPER[(MipsCpu.vuOpcode&0x3F) ]();	
//			if(debug_VU0 == 1 ) PrintToEmuOutput(debugTempTextVU0);

			/* second lower */ 
			MipsCpu.vuOpcode = LowerOp;
			COP2_MI_VU0_LOWER[(MipsCpu.vuOpcode >> 25) & 0x7F]();
//			if(debug_VU0 == 1 ) PrintToEmuOutput(debugTempTextVU0);
		}
		
		/*Update the Number of Instructions*/
		MipsCpu.Nb_instructions++;		

 
		if ( VectorUnit0.PC > 0x3FF8 )  VectorUnit0.halt = 1 ;

}

/*
Execute a MicroProgram
*/      
void VU0_Execute( void ) {

	VU0_MaxOpcode = 0;

	while ( VectorUnit0.halt == 0 ) {  	VectorUnit0_Execute_OneOpcode(); }

	VectorUnit0_Execute_OneOpcode();
}


  
 
void VU0_NI(void){PrintDebugVUopcode();VectorUnit0.halt = 1;}



/********************************************************************************************/
/*							UPPER MICROCODE													*/
/********************************************************************************************/
		

void VU0_COP2_MI_VU0_UPPER_T60	(void){	COP2_MI_VU0_UPPER_T60[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
void VU0_COP2_MI_VU0_UPPER_T61	(void){	COP2_MI_VU0_UPPER_T61[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
void VU0_COP2_MI_VU0_UPPER_T62	(void){	COP2_MI_VU0_UPPER_T62[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
void VU0_COP2_MI_VU0_UPPER_T63	(void){	COP2_MI_VU0_UPPER_T63[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
	



void VU0_ABS	(void)	{	vuABS	(VectorUnit0);   }



void VU0_ADD	(void)	{	vuADD	(VectorUnit0);	}	
void VU0_ADDi	(void)	{	vuADDi	(VectorUnit0);	}	
void VU0_ADDq	(void)	{	vuADDq	(VectorUnit0);	}	
void VU0_ADDbc	(void)	{	vuADDbc	(VectorUnit0);	}


void VU0_ADDA	(void)	{	vuADDA	(VectorUnit0);	}
void VU0_ADDAq	(void)	{	vuADDAq	(VectorUnit0);	}
void VU0_ADDAi	(void)	{	vuADDAi	(VectorUnit0);	}
void VU0_ADDAbc	(void)	{	vuADDAbc(VectorUnit0);	}


void VU0_CLIP	(void)	{	vuCLIP	(VectorUnit0);	}

	
void VU0_FTOI0	(void)	{	vuFTOI0	(VectorUnit0);	}
void VU0_FTOI4	(void)	{	vuFTOI4	(VectorUnit0);	}
void VU0_FTOI12	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_FTOI15	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	 


void VU0_ITOF0	(void)	{	vuITOF0	(VectorUnit0);	}
void VU0_ITOF4	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_ITOF12	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	
void VU0_ITOF15	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	


			
void VU0_MADD	(void)	{	vuMADD	(VectorUnit0);	}	
void VU0_MADDi	(void)	{	vuMADDi	(VectorUnit0);	}	
void VU0_MADDq	(void)	{	vuMADDq	(VectorUnit0);	}
void VU0_MADDbc	(void)	{	vuMADDbc(VectorUnit0);	}

	
void VU0_MADDA	(void)	{	vuMADDA	(VectorUnit0);	}
void VU0_MADDAi	(void)	{	vuMADDAi(VectorUnit0);	}
void VU0_MADDAq	(void)	{	vuMADDAq(VectorUnit0);	}
void VU0_MADDAbc(void)	{ 	vuMADDAbc(VectorUnit0);  }	



void VU0_MAX	(void)	{	vuMAX	(VectorUnit0);	}
void VU0_MAXi	(void)	{	vuMAXi	(VectorUnit0);	}		
void VU0_MAXbc	(void)	{	vuMAXbc	(VectorUnit0);	}	

void VU0_MINI	(void)	{	vuMINI	(VectorUnit0);	}
void VU0_MINIi	(void)	{	vuMINIi	(VectorUnit0);	}	
void VU0_MINIbc	(void)	{	vuMINIbc(VectorUnit0);	}


void VU0_MSUB	(void)	{	vuMSUB	(VectorUnit0);	}
void VU0_MSUBi	(void)	{	vuMSUBi	(VectorUnit0);	}
void VU0_MSUBq	(void)	{	vuMSUBq	(VectorUnit0);	}
void VU0_MSUBbc	(void)	{	vuMSUBbc(VectorUnit0);  }

		
void VU0_MSUBA	(void)	{	vuMSUBA	(VectorUnit0);	}
void VU0_MSUBAi	(void)	{	vuMSUBAi(VectorUnit0);	}
void VU0_MSUBAq	(void)	{	vuMSUBAq(VectorUnit0);	}
void VU0_MSUBAbc(void)	{	vuMSUBAbc(VectorUnit0);	}



void VU0_MUL	(void)	{	vuMUL	(VectorUnit0);	}
void VU0_MULi	(void)	{	vuMULi	(VectorUnit0);	}	
void VU0_MULq	(void)	{	vuMULq	(VectorUnit0);	}
void VU0_MULbc	(void)	{	vuMULbc	(VectorUnit0);	}
		
	
void VU0_MULA	(void)	{	vuMULA	(VectorUnit0);	}		
void VU0_MULAi	(void)	{	vuMULAi	(VectorUnit0);	}	
void VU0_MULAq	(void)	{	vuMULAq	(VectorUnit0);	}	
void VU0_MULAbc	(void)	{	vuMULAbc(VectorUnit0);	}	


void VU0_NOP	(void)	{	vuNOP	(VectorUnit0);	}


void VU0_OPMULA	(void)	{	vuOPMULA(VectorUnit0);	}
void VU0_OPMSUB	(void)	{	vuOPMSUB(VectorUnit0);	}



void VU0_SUB	(void)	{	vuSUB	(VectorUnit0);	}	
void VU0_SUBi	(void)	{	vuSUBi	(VectorUnit0);	}	
void VU0_SUBq	(void)	{	vuSUBq	(VectorUnit0);	}			
void VU0_SUBbc	(void)	{	vuSUBbc	(VectorUnit0);	}			



void VU0_SUBBA	(void)	{	vuSUBA	(VectorUnit0); 	}
void VU0_SUBAi	(void)	{	vuSUBAi	(VectorUnit0);	}
void VU0_SUBAq	(void)	{	vuSUBAq	(VectorUnit0);	} 
void VU0_SUBAbc	(void)	{	vuSUBAbc(VectorUnit0);	} 		
	


/********************************************************************************************/
/*							LOWER MICROCODE													*/
/********************************************************************************************/


void VU0_COP2_MI_VU0_LOWER_T64_60(void){COP2_MI_VU0_LOWER_T64_60[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU0_COP2_MI_VU0_LOWER_T64_61(void){COP2_MI_VU0_LOWER_T64_61[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU0_COP2_MI_VU0_LOWER_T64_62(void){COP2_MI_VU0_LOWER_T64_62[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU0_COP2_MI_VU0_LOWER_T64_63(void){COP2_MI_VU0_LOWER_T64_63[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU0_COP2_MI_VU0_LOWER_T64	 (void){COP2_MI_VU0_LOWER_T64[(MipsCpu.vuOpcode & 0x3F)]();}



void VU0_B		(void)	{	vuB		(VectorUnit0);	}		
void VU0_BAL	(void)	{	vuBAL	(VectorUnit0);	}

 
void VU0_DIV	(void)	{	vuDIV	(VectorUnit0);	}


void VU0_EATAN	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_EATANxy(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_EATANxz(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}


void VU0_EEXP	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_ELENG	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}

void VU0_ERCPR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_ERLENG	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_ERSADD	(void)	{	vuERSADD(VectorUnit0); }
void VU0_ERSQRT	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}


void VU0_ESADD	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	
void VU0_ESIN	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_ESQRT	(void)	{	vuESQRT	(VectorUnit0);	}
void VU0_ESUM	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	



void VU0_FCAND	(void)	{	vuFCAND	(VectorUnit0);	}	
void VU0_FCEQ	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}		
void VU0_FCGET	(void)	{	vuFCGET	(VectorUnit0);	}	
void VU0_FCOR	(void)	{	vuFCOR	(VectorUnit0);	}
void VU0_FCSET	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	



void VU0_FMAND	(void)	{	vuFMAND	(VectorUnit0);  }	
void VU0_FMEQ	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	
void VU0_FMOR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_FSAND	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}



void VU0_FSEQ	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_FSOR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_FSSET	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
		
	
 

void VU0_IADD	(void)	{	vuIADD	(VectorUnit0); 	}
void VU0_IADDI	(void)	{	vuIADDI	(VectorUnit0);	}
void VU0_IADDIU	(void)	{	vuIADDIU(VectorUnit0);	}
void VU0_IAND	(void)	{	vuIAND	(VectorUnit0);	}



void VU0_IBEQ	(void)	{	vuIBEQ	(VectorUnit0);	}
void VU0_IBGEZ	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_IBGTZ	(void)	{	vuIBGTZ	(VectorUnit0);	}
void VU0_IBLEZ	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_IBLTZ	(void)	{	vuIBLTZ	(VectorUnit0);	}	
void VU0_IBNE	(void)	{	vuIBNE	(VectorUnit0);	}	



void VU0_ILW	(void)	{	vuILW	(VectorUnit0);	}
void VU0_ILWR	(void)	{	vuILWR	(VectorUnit0);	}
void VU0_IOR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_ISW	(void)	{	vuISW	(VectorUnit0);	}
void VU0_ISUB	(void)	{	vuISUB	(VectorUnit0);	}
void VU0_ISUBIU	(void)	{   vuISUBIU(VectorUnit0);	}
void VU0_ISWR	(void)	{	vuISWR	(VectorUnit0);	}	


 
void VU0_JALR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_JR		(void)	{	vuJR	(VectorUnit0);  }		


void VU0_LQ		(void)	{	vuLQ	(VectorUnit0);	}
void VU0_LQD	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_LQI	(void)	{	vuLQI	(VectorUnit0);	}	
	

void VU0_MFIR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_MFP	(void)	{	vuMFP	(VectorUnit0);	}
void VU0_MOVE	(void)	{	vuMOVE	(VectorUnit0);	}
void VU0_MR32	(void)	{	vuMR32	(VectorUnit0);	}
void VU0_MTIR	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}



void VU0_RGET	(void)	{	vuRGET	(VectorUnit0);  }
void VU0_RINIT	(void)	{	vuRINIT	(VectorUnit0);  }
void VU0_RNEXT	(void)	{	vuRNEXT (VectorUnit0);  }
void VU0_RSQRT	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}
void VU0_RXOR	(void)	{	vuRXOR	(VectorUnit0);  }



void VU0_SQ		(void)	{	vuSQ	(VectorUnit0);	}
void VU0_SQD	(void)	{	vuSQD	(VectorUnit0);	}
void VU0_SQI	(void)	{	vuSQI	(VectorUnit0);	}
void VU0_SQRT	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}	
	
	
void VU0_WAITQ	(void)	{	vuWAITQ	(VectorUnit0);	}
void VU0_WAITP	(void)	{	vuWAITQ	(VectorUnit0);	}



void VU0_XITOP	(void)	{	PrintDebugVUopcode();VectorUnit0.halt = 1;}


/* Only with VectorUnit0 */
	
void VU0_XTOP	(void)	{}	


void VU0_XGKICK	(void)	{}



