/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"
 
#include "r5900_main.h"

#include "VU.h"

#define		COP2_FLOAT_MAX	2147483648.0
#define		COP2_FLOAT_MIN	-2147483648.0




float VectorUnit0_UPDATE_MAC_REG_X ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0008 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0008) ; 


	if ( (double)val < (float)0.0f ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0080 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0080) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0800 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0800) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x8000 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x8000) ; 

	return ((float)val); 
} 

float VectorUnit0_UPDATE_MAC_REG_Y ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0004 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0004) ; 


	if ( (double)val < (float)0.0 ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0040 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0040) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0400 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0400) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x4000 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x4000) ; 

	return ((float)val); 
} 

float VectorUnit0_UPDATE_MAC_REG_Z ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0002 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0002) ; 


	if ( (double)val < (float)0.0 ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0020 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0020) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0200 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0200) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x2000 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x2000) ; 

	return ((float)val); 
} 

float VectorUnit0_UPDATE_MAC_REG_W ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0001 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0001) ; 


	if ( (double)val < (float)0.0f ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0010 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0010) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x0100 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x0100) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] | 0x1000 ; 
	else VectorUnit0.CCR[VU_MAC_FLAG] = VectorUnit0.CCR[VU_MAC_FLAG] & (~0x1000) ; 

	return ((float)val); 
} 



void VectorUnit0_UPDATE_STAT_REG( void ) {


	_u32 Flag_Z = 0;
	_u32 Flag_S = 0;
	_u32 Flag_U = 0;
	_u32 Flag_O = 0;
	_u32 Flag_I = 0;
	_u32 Flag_D = 0;
	

	if ( (VectorUnit0.CCR[VU_MAC_FLAG] & 0x000F ) != 0 ) {
		VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | 0x1;
		Flag_Z = 1;
	}

	if ( (VectorUnit0.CCR[VU_MAC_FLAG] & 0x00F0 ) != 0 ) {
			VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | 0x2;
		Flag_S = 1;
	}

	if ( (VectorUnit0.CCR[VU_MAC_FLAG] & 0x0F00 ) != 0 ) {
			VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | 0x4;
		Flag_U = 1;
	}
	
	if ( (VectorUnit0.CCR[VU_MAC_FLAG] & 0xF000 ) != 0 ) {
			VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | 0x8;
		Flag_O = 1;
	}



	VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | (( Flag_S | Flag_Z ) << 6);
	
	VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | (( Flag_S | Flag_S ) << 7);
	
	VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | (( Flag_U | Flag_S ) << 8);

	VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | (( Flag_O | Flag_S ) << 9);

}

void VectorUnit0_UPDATE_STAT_REG_DI( void ) {



	_u32 Flag_S = 0;
	_u32 Flag_I = 0;
	_u32 Flag_D = 0;
	

	if ( (VectorUnit0.CCR[VU_MAC_FLAG] & 0x00F0 ) != 0 ) 	Flag_S = 1;

	/*
	FLAG D - I
	*/
	
	Flag_I = (VectorUnit0.CCR[VU_STATUS_FLAG] >> 4) & 0x1;
	Flag_D = (VectorUnit0.CCR[VU_STATUS_FLAG] >> 5) & 0x1;


	VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | (( Flag_I | Flag_S ) << 10);

	VectorUnit0.CCR[VU_STATUS_FLAG] = 	VectorUnit0.CCR[VU_STATUS_FLAG] | (( Flag_D | Flag_S ) << 11);


}










float VectorUnit1_UPDATE_MAC_REG_X ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0008 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0008) ; 


	if ( (double)val < (float)0.0f ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0080 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0080) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0800 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0800) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x8000 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x8000) ; 

	return ((float)val); 
} 

float VectorUnit1_UPDATE_MAC_REG_Y ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0004 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0004) ; 


	if ( (double)val < (float)0.0 ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0040 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0040) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0400 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0400) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x4000 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x4000) ; 

	return ((float)val); 
} 

float VectorUnit1_UPDATE_MAC_REG_Z ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0002 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0002) ; 


	if ( (double)val < (float)0.0 ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0020 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0020) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0200 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0200) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x2000 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x2000) ; 

	return ((float)val); 
} 

float VectorUnit1_UPDATE_MAC_REG_W ( double val ) { 
	if ( (double)val == (float)0.0f ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0001 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0001) ; 


	if ( (double)val < (float)0.0f ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0010 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0010) ; 

	if ( (double)val < (float)COP2_FLOAT_MIN ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x0100 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x0100) ; 

	if ( (double)val > (float)COP2_FLOAT_MAX ) VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] | 0x1000 ; 
	else VectorUnit1.CCR[VU_MAC_FLAG] = VectorUnit1.CCR[VU_MAC_FLAG] & (~0x1000) ; 

	return ((float)val); 
} 



void VectorUnit1_UPDATE_STAT_REG( void ) {


	_u32 Flag_Z = 0;
	_u32 Flag_S = 0;
	_u32 Flag_U = 0;
	_u32 Flag_O = 0;
	_u32 Flag_I = 0;
	_u32 Flag_D = 0;
	

	if ( (VectorUnit1.CCR[VU_MAC_FLAG] & 0x000F ) != 0 ) {
		VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | 0x1;
		Flag_Z = 1;
	}

	if ( (VectorUnit1.CCR[VU_MAC_FLAG] & 0x00F0 ) != 0 ) {
			VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | 0x2;
		Flag_S = 1;
	}

	if ( (VectorUnit1.CCR[VU_MAC_FLAG] & 0x0F00 ) != 0 ) {
			VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | 0x4;
		Flag_U = 1;
	}
	
	if ( (VectorUnit1.CCR[VU_MAC_FLAG] & 0xF000 ) != 0 ) {
			VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | 0x8;
		Flag_O = 1;
	}



	VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | (( Flag_S | Flag_Z ) << 6);
	
	VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | (( Flag_S | Flag_S ) << 7);
	
	VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | (( Flag_U | Flag_S ) << 8);

	VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | (( Flag_O | Flag_S ) << 9);

}

void VectorUnit1_UPDATE_STAT_REG_DI( void ) {



	_u32 Flag_S = 0;
	_u32 Flag_I = 0;
	_u32 Flag_D = 0;
	

	if ( (VectorUnit1.CCR[VU_MAC_FLAG] & 0x00F0 ) != 0 ) {
			//VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | 0x2;
		Flag_S = 1;
	}


	
	Flag_I = (VectorUnit1.CCR[VU_STATUS_FLAG] >> 4) & 0x1;
	Flag_D = (VectorUnit1.CCR[VU_STATUS_FLAG] >> 5) & 0x1;


	VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | (( Flag_I | Flag_S ) << 10);

	VectorUnit1.CCR[VU_STATUS_FLAG] = 	VectorUnit1.CCR[VU_STATUS_FLAG] | (( Flag_D | Flag_S ) << 11);


}








