/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h> 
#include <float.h>
#include <math.h>

#include "nSX2.h"

#include "VU.h"


void	VU_init ( void ) {
	int 		result;				//fonction return
	int 		boucle;				//loop

#ifdef EMU_LOG
	EMU_LOG("[VU0]Initialisation");
#endif

	/* VU 0 Init */
	VectorUnit0.CCR[ VU_STATUS_FLAG ] 		= 0;
	VectorUnit0.CCR[ VU_MAC_FLAG ] 			= 0;
	VectorUnit0.CCR[ VU_CLIPPIN_FLAG ] 		= 0;
	VectorUnit0.CCR[ VU_FBRST_REGISTER ] 	= 0;
	VectorUnit0.CCR[ VU_VPU_STAT_RGISTER ] 	= 0;

	for ( boucle = 0 ; boucle < 4 ; boucle ++ ) {
		for ( result = 0 ; result < 32 ; result++ ) {
	     	VectorUnit0.CPR_p_float[result][boucle]=(float *)&(VectorUnit0.CPR[result][boucle]);
			(*VectorUnit0.CPR_p_float[result][boucle]) = 0.0;
         }
	}

	*(VectorUnit0.CPR_p_float[0][3]) = (float)1.0;

	for ( boucle = 0 ; boucle < 32 ; boucle ++ ) {
     	VectorUnit0.CCR_p_float[boucle]=(float *)&(VectorUnit0.CCR[boucle]);
					
	}

	for ( boucle = 0 ; boucle < 4 ; boucle ++ ) {
     	VectorUnit0.ACC_p_float[boucle]=(float *)&(VectorUnit0.ACC[boucle]);
		(*VectorUnit0.ACC_p_float[boucle]) = 0.0;
	}

			
	memset( VectorUnit0.Mem, 0, sizeof( _u8 ) * 4096 );
	memset( VectorUnit0.MicroMem , 0, sizeof( _u8 ) * 4096 );


#ifdef EMU_LOG
	EMU_LOG("[VU1]Initialisation");
#endif

	VectorUnit1.CCR[ VU_STATUS_FLAG ] 		= 0;
	VectorUnit1.CCR[ VU_MAC_FLAG ] 			= 0;
	VectorUnit1.CCR[ VU_CLIPPIN_FLAG ] 		= 0;
			
	VectorUnit1.CCR[ VU_VPU_STAT_RGISTER ] 	= 0;

	for ( boucle = 0 ; boucle < 4 ; boucle ++ ) {
		for ( result = 0 ; result < 32 ; result++ ) {
	     	VectorUnit1.CPR_p_float[result][boucle]=(float *)&(VectorUnit1.CPR[result][boucle]);
			(*VectorUnit1.CPR_p_float[result][boucle]) = 0.0;
		}
	}

	*(VectorUnit1.CPR_p_float[0][3]) = (float)1.0;

	for ( boucle = 0 ; boucle < 32 ; boucle ++ ) {
	   	VectorUnit1.CCR_p_float[boucle]=(float *)&(VectorUnit1.CCR[boucle]);
	}

	for ( boucle = 0 ; boucle < 4 ; boucle ++ ) {
	   	VectorUnit1.ACC_p_float[boucle]=(float *)&(VectorUnit1.ACC[boucle]);
		(*VectorUnit1.ACC_p_float[boucle]) = 0.0;
 	}


	memset( VectorUnit1.Mem, 		0, sizeof( _u8 ) * 16384 );
	memset( VectorUnit1.MicroMem , 	0, sizeof( _u8 ) * 16384 );


}










