#ifndef _DLL_H_
#define _DLL_H_

#include <windows.h>

#ifdef BUILDING_DLL
# define DLLIMPORT extern "C" __declspec(dllexport)
#else /* Not BUILDING_DLL */
# define DLLIMPORT extern "C" __declspec(dllimport)
#endif /* Not BUILDING_DLL */



typedef struct _pluginDebuger {


	/* Pointer to All Area Memory */
	_u8	* MipsMemory;
	_u8	* SpecialAreaMemory;
	_u8	* GSAreaMemory;
	_u8 * BiosMemory;
	_u8 * SPRMemory;

	
	DMAController 			*DmaC;
	GIFGSInterface 			*GIF;
	INTController 			*IntC;
	STimer 					*Timer[ 8 ];
	VPUDataDecompresionUnit	*VIF[2];

	VPU0			*VectorUnit0;	
	VPU1			*VectorUnit1;	

	Mips_CPU * MipsCpu;
	
	Bios_Hw  *Ps2Bios;

}pluginDebuger;

#ifdef BUILDING_DLL

extern pluginDebuger * FromEmu;
extern HINSTANCE MainApp;

#define EXPORT(DEF) extern "C" DEF __export CALLBACK


EXPORT(int) 	DLL_OpenDebuger ( HINSTANCE hINST );
EXPORT(int) 	DLL_CloseDebuger ( HINSTANCE hINST );
EXPORT(int) 	DLL_InitDebuger ( pluginDebuger *fPlugin );
EXPORT(int) 	DLL_ShutdownDebuger ( );
EXPORT(void) 	DLL_ShowHideDebuger (HWND hwnd );
EXPORT(void) 	DLL_SendBreak ( );

EXPORT(_u32)	PS2EgetLibType();
EXPORT(char *) 	PS2EgetLibName ( void );
EXPORT(_u32) 	PS2EgetLibVersion ( );


#else

void (* DBG_HelloWorld)		(void);
int  (*	DBG_OpenDebuger) 	( HINSTANCE hINST );
int  (*	DBG_CloseDebuger) 	( HINSTANCE hINST );
void (* DBG_InitDebuger) 	( pluginDebuger *fPlugin);
void (* DBG_ShutdownDebuger) 	( void );
void (* DBG_ShowHideDebuger)(HWND hwnd );
void (* DBG_SendBreak)		( );
#endif



#endif /* _DLL_H_ */
