//---------------------------------------------------------------------------


#pragma hdrstop

#include <stdlib.h>
#include <stdio.h>

#include "FormMainwindow.h"
#include "Deci2.h"
#include "Netmp.h"
#include "Dcmp.h"
#include "Dbgp.h"
#include "Ttpy.h"


//---------------------------------------------------------------------------

#pragma package(smart_init)



char	Host_App_Name[1024];
__int64	EEBoot;
__int64	IOPBoot;


void NETMP_Log ( char * ftext  , ...   ) {
	char LogText[ 1024 ];
    char LogText2[ 1024 ];

    va_list ap;
   	va_start (ap, ftext);
   	vsprintf (LogText, ftext, ap);
   	va_end (ap);

  	sprintf(LogText2,"[NETMP]%s",LogText);


    MainWindow->Memo->Lines->Add( AnsiString(LogText2).c_str() );


   	sprintf(LogText,"[RDBG]%s\n",LogText2);
    SendPacket_TttpyMessage( LogText );


}




void	DecodeNetmp( ) {

	NETMPHEAD 		* NetmpHdr;
	NETMP_CONNECT 	* Netmp_Cnt;


	sceDeci2Hdr * Deci2Hdr;

	Deci2Hdr = (sceDeci2Hdr *) ( InBuf  );

    NetmpHdr = ( NETMPHEAD *)( InBuf + InBuf_done );
    InBuf_done = InBuf_done + NETMPHEAD_SZ;

/*
	NETMP_LOG( 	" CODE:" + IntToStr(NetmpHdr->code ) +
				" RESULT:" +IntToStr(NetmpHdr->result ) );
*/
	switch( NetmpHdr->code ) {
    	case NETMP_CODE_CONNECT:
#ifdef  NETMP_LOG
        	NETMP_LOG( "Connect" );
#endif
 			while( InBuf_done < InBuf_Lenght ) {
    			InBuf_done = InBuf_done + NETMP_CONNECT_SZ ;
           		CreatePacket_NETMP ( NETMP_CODE_CONNECTR );
 			}

			SendPacket_NETMP();



		break;

		case NETMP_CODE_MESSAGE:
			strncpy(Host_App_Name,( InBuf + InBuf_done ), ( Deci2Hdr->len -  ( DECI2HEAD_SZ + NETMPHEAD_SZ )));
            Host_App_Name[( Deci2Hdr->len -  ( DECI2HEAD_SZ + NETMPHEAD_SZ )) ] = 0;
#ifdef  NETMP_LOG
 			NETMP_LOG( "Msg : Host,AppName %s", Host_App_Name  );
#endif
			CreatePacket_NETMP ( NETMP_CODE_MESSAGER );
 			SendPacket_NETMP();



		break;

		case NETMP_CODE_RESET:

            EEBoot  =  *(__int64*)( InBuf + InBuf_done );
			IOPBoot =  *(__int64*)( InBuf + InBuf_done + 8);
            Host_App_Name[( Deci2Hdr->len -  ( DECI2HEAD_SZ + NETMPHEAD_SZ )) ] = 0;
#ifdef  NETMP_LOG
        	NETMP_LOG( "Reset (params : EE = %d, IOP = %d )",EEBoot,IOPBoot );
#endif
 			CreatePacket_NETMP ( NETMP_CODE_RESETR );

			SendPacket_NETMP();

			SendPacket_DcmpReset(DECI2_NODE_ID_HOST, DECI2_NODE_ID_HOST,
				DCMP_CODE_CONNECT, DECI2_NODE_ID_IOP);

			SendPacket_DcmpReset(DECI2_NODE_ID_HOST, DECI2_NODE_ID_HOST,
				DCMP_CODE_CONNECT, DECI2_NODE_ID_EE);

 			SendPacket_DcmpReset(DECI2_NODE_ID_IOP, DECI2_NODE_ID_HOST,
				NETMP_CODE_CONNECTR, DECI2_PROTO_ILOADP);




		break;

		case NETMP_CODE_STATUS:
#ifdef  NETMP_LOG
        	NETMP_LOG( "Status");
#endif

 			CreatePacket_NETMP ( NETMP_CODE_STATUSR );
 			SendPacket_NETMP();
		break;




		default:
#ifdef  NETMP_LOG
        	NETMP_LOG(" CODE UNKNOW: 0x%x", NetmpHdr->code );
#endif
			InBuf_done = InBuf_Lenght;
		break;


	}



}



void	CreatePacket_NETMP ( int fCode ) {

	NETMPHEAD		*NetMPHdr;
    NETMP_STATUS 	*NetMPStat;



    NetMPHdr = ( NETMPHEAD *) ( OutBuf + sizeof(sceDeci2Hdr ) + OutBuf_Lenght );
    NetMPStat = ( NETMP_STATUS *) ( OutBuf + sizeof(sceDeci2Hdr ) + OutBuf_Lenght );


    switch( fCode ) {
    	case NETMP_CODE_CONNECTR:
            OutBuf_Lenght = OutBuf_Lenght + NETMPHEAD_SZ;
            NetMPHdr->code 		= NETMP_CODE_CONNECTR;
            NetMPHdr->result 	= NETMP_ERR_OK;
		break;

    	case NETMP_CODE_MESSAGER:
			OutBuf_Lenght = OutBuf_Lenght + NETMPHEAD_SZ;
            NetMPHdr->code 		= NETMP_CODE_MESSAGER;
            NetMPHdr->result 	= NETMP_ERR_OK;
		break;

    	case NETMP_CODE_STATUSR:
            NetMPStat->code 	= NETMP_CODE_STATUSR;
            NetMPStat->result 	= NETMP_ERR_OK;
           	NetMPStat->priority = 255;
           	NetMPStat->protocol = DECI2_PROTO_ESDBGP;
          	NetMPStat->time		= 5;
            strcpy( (char*)(NetMPStat + NETMP_STATUS_SZ),Host_App_Name);


            OutBuf_Lenght = OutBuf_Lenght + NETMPHEAD_SZ + strlen(Host_App_Name);

		break;

    	case NETMP_CODE_RESETR:
            OutBuf_Lenght = OutBuf_Lenght + NETMPHEAD_SZ;
            NetMPHdr->code 		= NETMP_CODE_RESETR;
            NetMPHdr->result 	= NETMP_ERR_OK;
		break;



        default:
            NETMP_LOG("[SEND] CODE UNKNOW: 0x%x", fCode);

		break;

	}



}

void SendPacket_NETMP() {
	sceDeci2Hdr	*Deci2Hdr;

	Deci2Hdr = ( sceDeci2Hdr *)OutBuf;

    Deci2Hdr->proto 	= DECI2_PROTO_NETMP;
    Deci2Hdr->src 		= DECI2_NODE_ID_HOST;
    Deci2Hdr->dest 		= DECI2_NODE_ID_HOST;
    Deci2Hdr->len		= sizeof(sceDeci2Hdr ) + OutBuf_Lenght;

	ClientSocket->SendBuf(OutBuf,Deci2Hdr->len);
  	//NETMP_LOG("[SEND] " + IntToStr(Deci2Hdr->len) + " bytes" );
}



