//---------------------------------------------------------------------------

#ifndef NetmpH
#define NetmpH

/*
 * netmp
 */

typedef struct _NETMPHEAD{
    unsigned char  code;
    unsigned char  result;
} NETMPHEAD;

#define NETMPHEAD_SZ	sizeof(NETMPHEAD)

typedef struct _NETMP_CONNECT{
    unsigned char  priority;
    unsigned char  unused;
    unsigned short protocol;
} NETMP_CONNECT;

#define NETMP_CONNECT_SZ	sizeof(NETMP_CONNECT)


typedef struct _NETMP_STATUS{
    unsigned char  code;
    unsigned char  result;
    unsigned short pad0;
    unsigned char  priority;
    unsigned char  unused;
    unsigned short protocol;
    unsigned long  time;
	//char *         str;
} NETMP_STATUS;

#define NETMP_STATUS_SZ	sizeof(NETMP_STATUS)




/* netmp message code */
#define NETMP_CODE_CONNECT	0	/* connect request */
#define NETMP_CODE_CONNECTR	1	/* connect reply   */
#define NETMP_CODE_RESET	2	/* reset request   */
#define NETMP_CODE_RESETR	3	/* reset reply     */
#define NETMP_CODE_MESSAGE	4	/* message request */
#define NETMP_CODE_MESSAGER	5	/* message reply   */
#define NETMP_CODE_STATUS	6	/* status request  */
#define NETMP_CODE_STATUSR	7	/* status reply    */
#define NETMP_CODE_KILL		8	/* kill request    */
#define NETMP_CODE_KILLR	9	/* kill reply      */
#define NETMP_CODE_VERSION	10	/* version request */
#define NETMP_CODE_VERSIONR	11	/* version reply   */

/* netmp result code */
#define NETMP_ERR_OK		0	/* good            */
#define NETMP_ERR_INVAL		1	/* invalid request */
#define NETMP_ERR_BUSY		2	/* protocol busy   */
#define NETMP_ERR_NOTCONN	3	/* can not connect */
#define NETMP_ERR_ALREADYCONN	4	/* already connect */
#define NETMP_ERR_NOMEM		5	/* no memory       */
#define NETMP_ERR_NOPROTO	6	/* no protocol     */


#define	NETMP_CODE_RESETR_DCMP	255
/*************************************************************************/

#define		NETMP_LOG NETMP_Log
//#undef      NETMP_LOG

void	DecodeNetmp();
void	CreatePacket_NETMP ( int fCode );
void SendPacket_NETMP();




//---------------------------------------------------------------------------
#endif
