/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Rpc_services.h"
#include "../CDVDiso.h"

void cdvdfsv3_sceCdTrayReq(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout);

//ENTRYPOINT
void sifcall_cdvd(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	switch (call->rpc_number) {
	case CDVDRPC_FINDFILE:
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvd] CDVD_FindFile(\"%s\") => ", bin);
#endif
		*bout=CDVD_findfile((char*)bin, (struct TocEntry*)&bin[1024/4]);
#ifdef RPC_LOG
		RPC_LOG("%sfound\n", *bout?"":"not ");
#endif
		break;
	case CDVDRPC_GETDIR_REQ:
		*bout=CDVD_GetDir_RPC_request((char*)&bin[4/4], (char*)&bin[1024/4], bin[0]);
		break;
	case CDVDRPC_GETDIR_ENT:
		*bout=CDVD_GetDir_RPC_get_entries((struct TocEntry*)&bin[1024/4], bin[0]);
		break;
	case CDVDRPC_STOP:
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvd] CDVD_Stop()\n");
#endif
		break;//the most simple one :D
	case CDVDRPC_TRAYREQ:
		cdvdfsv3_sceCdTrayReq(call, bin, bout);
		break;
	case CDVDRPC_DISKREADY:
		*bout = 2;
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvd] CDVD_DiskReady(%d) => %d\n", bin[0], *bout);
#endif
		break;
	default:
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvd] <%d> function is not implemented (version 2.0?!?)\n", call->rpc_number);
#endif
		*bout=-1;	//general fail
	}
}