// __________________________________________________________________________________________________
//
//			$Archive:  $
//			$Revision:  $
//			$Author: Fires $ 
//			$Modtime:  $  
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
// M O D U L E  B E G I N ///////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

#include <windows.h> 
//#include <winlib.h>
#include <windowsx.h>
#include <stdio.h>



#include "resource.h"
#include "../Plugins/sif.h"
#include "_BldNum.h"


///////// Shadowpri
#define MAX_NUMBER_CDVD_PLUGINS 20
#define MAX_LENGTH_CDVD_PLUGINS 30

char CDVDPLUGINS [MAX_NUMBER_CDVD_PLUGINS][MAX_LENGTH_CDVD_PLUGINS] ;
////////

extern "C"
{
	#include"Common.h"
	#include "RPC/RPC_Services.h"
	#include "Todo.h"
	#include "Misc.h"
}

char plugin[1024] = "plugins/CDVDBin.dll";
char path[1024] = "plugins/";

#include "main.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////
// T Y P E D E F S / D E F I N E S //////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

static DWORD dwTlsIndex;		// address of shared memory
HINSTANCE g_hInstance = NULL;

void DeInitialize( void );

/////////////////////////////////////////////////////////////////////////////////////////////////////
// I M P L E M E N T A T I O N //////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

// __________________________________________________________________________________________________
// DllMain
//

void ShowMessage(LPSTR lpszMessage) 
{ 
   MessageBox(NULL, lpszMessage, "SIF Plugin", MB_OK); 
} 

BOOL APIENTRY DllMain(HINSTANCE hinstDLL,  // DLL module handle
                      DWORD fdwReason,              // reason called
                      LPVOID lpvReserved)           // reserved
{ 
	LPVOID lpvData; 
	BOOL fIgnore; 
	
	switch (fdwReason)
	{
	// The DLL is loading due to process 
	// initialization or a call to LoadLibrary. 		
	case DLL_PROCESS_ATTACH: 
		
		// Allocate a TLS index.		
		if ((dwTlsIndex = TlsAlloc()) == 0xFFFFFFFF) 
			return FALSE; 
		
	// No break: Initialize the index for first thread.		
	// The attached process creates a new thread. 		
	case DLL_THREAD_ATTACH: 
		
		// Initialize the TLS index for this thread.
		lpvData = (LPVOID) LocalAlloc(LPTR, 256); 
		if (lpvData != NULL) 
			fIgnore = TlsSetValue(dwTlsIndex, lpvData); 
		
		break; 
		
	// The thread of the attached process terminates.		
	case DLL_THREAD_DETACH: 
		
		// Release the allocated memory for this thread.
			lpvData = TlsGetValue(dwTlsIndex); 
		if (lpvData != NULL) 
			LocalFree((HLOCAL) lpvData); 
		
		break; 
		
	// DLL unload due to process termination or FreeLibrary. 
	case DLL_PROCESS_DETACH: 
		
		// Release the allocated memory for this thread.		
		lpvData = TlsGetValue(dwTlsIndex); 
		if (lpvData != NULL) 
			LocalFree((HLOCAL) lpvData); 
		
		// Release the TLS index.		
		TlsFree(dwTlsIndex); 
		break; 
		
	default: 
		break; 
	} 	
	g_hInstance = hinstDLL;
	
	return TRUE; 
} 

// __________________________________________________________________________________________________
// GetDllInfo
//
void CALLBACK GetDllInfo (PLUGIN_INFO* _PluginInfo) 
{
	_PluginInfo->Version = 0x0005;
	_PluginInfo->Type = PLUGIN_TYPE_SIF;
	sprintf(_PluginInfo->Name, "SIF Plugin");
}


/* VERSION INFORMATION */



#define PS2E_LT_SIF				0x10


const unsigned char version  = 0;			
const unsigned char revision = 0;
const unsigned char build    = 10;    

static char *libraryName     = "SIF Plugin";

u32		CALLBACK PS2EgetLibType()		{	return PS2E_LT_SIF;	}
	
char*	CALLBACK PS2EgetLibName()		{	return libraryName;	}

u32		CALLBACK PS2EgetLibVersion()	{	return version<<16|revision<<8|build;	}







// __________________________________________________________________________________________________
// CloseDLL
//
void CALLBACK CloseDLL (void) 
{
}

// __________________________________________________________________________________________________
// DllAbout
//
void CALLBACK DllAbout ( HWND _hParent) 
{
	MessageBox(_hParent, "DllAbout", "DllAbout", MB_OK);
}

// __________________________________________________________________________________________________
// DllConfig
//
BOOL CALLBACK ConfigureDlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	WIN32_FIND_DATA FindData;
	HANDLE Find;
	HANDLE Lib;
	int ind=0;
	switch (uMsg) 
    { 
		case WM_INITDIALOG:
            {
				char tmpStr[256];
				_PS2EgetLibType    PS2E_GetLibType;
				_PS2EgetLibName    PS2E_GetLibName;
				_PS2EgetLibVersion PS2E_GetLibVersion;
				sprintf(tmpStr,"SIFplugin Version %d.%d", revision, build);
				SetWindowText(hwnd,tmpStr) ;
/*
				strcpy(tmpStr, "plugins/");
				strcat(tmpStr, "*.dll");
*/
				sprintf(tmpStr,"%s/plugins/*.dll",muadCurDir);

				Find = FindFirstFile(tmpStr, &FindData);
				do{

				sprintf(tmpStr,"%s/plugins/%s",muadCurDir,FindData.cFileName);

//				sprintf(tmpStr,"%s%s", "plugins/", FindData.cFileName);
				Lib = LoadLibrary(tmpStr);
				PS2E_GetLibType = (_PS2EgetLibType) GetProcAddress((HMODULE)Lib,"PS2EgetLibType");
				PS2E_GetLibName    = (_PS2EgetLibName) GetProcAddress((HMODULE)Lib,"PS2EgetLibName");
				PS2E_GetLibVersion = (_PS2EgetLibVersion) GetProcAddress((HMODULE)Lib,"PS2EgetLibVersion");

				if (PS2E_GetLibType != NULL && PS2E_GetLibName != NULL && PS2E_GetLibVersion != NULL) {
				unsigned long version = PS2E_GetLibVersion();
				long type = PS2E_GetLibType();
				sprintf(tmpStr, "%s %d.%d", PS2E_GetLibName(), (version>>8)&0xff, version&0xff);
				
					if (type & 0x8) { // DVD
					ind = SendDlgItemMessage(hwnd,IDC_DVD,LB_ADDSTRING,0,(LPARAM)tmpStr);
					sprintf(CDVDPLUGINS[ind],FindData.cFileName);
					}
				
				}
				
				FreeLibrary((HMODULE)Lib);
				
				} while (FindNextFile(Find,&FindData));
				
				SendDlgItemMessage(hwnd,IDC_DVD,LB_SETCURSEL,0,0);
				if (Find!=INVALID_HANDLE_VALUE) FindClose(Find);


			    SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"NapLink");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"CDVD");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"SjPcm");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"AmigaMod");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"FileIO");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"SystemMemory");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"Memory Card Server");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"OSD Sound");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"PS2 Pad 1");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"PS2 Pad 2");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"Xpad 1");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_ADDSTRING,0,(LPARAM)"Xpad 2");
				SendDlgItemMessage(hwnd,IDC_RPC,LB_SETCURSEL,1,0);

			
				if (CDVDLibName!=NULL) {
					SetDlgItemText(hwnd,IDC_LOADED_PLG,CDVDLibName());
					
				}
				else {
					SetDlgItemText(hwnd,IDC_LOADED_PLG,plugin);
					
				}
             return TRUE;
			}
		case WM_CLOSE:
			EndDialog(hwnd,0);
			break;

        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
			  case IDC_CONFIGDVD:
				  CDVDconfigure();
				  break;
			  
			  case IDC_ABOUTDVD:
				  CDVDabout();
				  break;

			  case IDC_TESTDVD:
				  CDVDtest();
				  break;

			  case IDC_LOADPLUGIN:
				   HWND hWC;
				  				
					hWC=GetDlgItem(hwnd,IDC_DVD);                      
					ind=ListBox_GetCurSel(hWC);
					
					sprintf(plugin,"%s%s",path,CDVDPLUGINS[ind]);	
					
					DeInitialize();
					if(LoadCDVDplugin(plugin) != 1){	//Asadr
					   
					   if (CDVDinit!=NULL) {	
						CDVDinit();
						setConfigValue("Plugins","CDVD",plugin);
						if (CDVDLibName!=NULL) {
							SetDlgItemText(hwnd,IDC_LOADED_PLG,CDVDLibName());
							
						}
						else {
							SetDlgItemText(hwnd,IDC_LOADED_PLG,plugin);
							
						}
					   }
					
					}
				  break;
			  case IDOK: 
				    				
					EndDialog(hwnd,1);
					break; 
			}
			break;
	 } 
	 return FALSE;
}

void CALLBACK DllConfig ( HWND _hParent )
{
	DialogBox(g_hInstance,MAKEINTRESOURCE(IDD_CONFIG),
		_hParent,(DLGPROC)ConfigureDlgProc);
}

// __________________________________________________________________________________________________
// DllTest
//
void CALLBACK DllTest ( HWND _hParent )
{
	MessageBox(_hParent, "DllTest", "DllTest", MB_OK);
}

// __________________________________________________________________________________________________
// Initialize
//
void CALLBACK Initialize (SSifInitialize _SifInitialize)
{
	g_SifInitialize = _SifInitialize;
	
    getConfigValue("Plugins","CDVD","",plugin) ;
	
	if ( !strcmp( plugin ,"" ) ) {   // If Default plugin not found in config file
		FindAndLoadAnyCDVDPlugin();	 // Find any cdvd plugin	
	}

	if(LoadCDVDplugin(plugin) != 1){	
	   CDVDinit();	
	}
	else MessageBox(NULL,"Could not find DVD plugin","Error",MB_OK);
	
	strncpy((char*)&RPCVER, "2000", 4);

	GetCurrentDirectory( 1024, muadCurDir );
}

void DeInitialize( void )
{
	if (CDVDshutdown!=NULL)
	{
		CDVDshutdown();
	}
	else ShowMessage("Critical Error,plugin not initialized");
}

int LastLoadOK = TRUE;

int CALLBACK Run_DVD ( void )
{	



	char fName[1024];

	if ( LastLoadOK == FALSE ) {

		CDVDshutdown();

		CDVDinit();

	}

	
	if(CDVDopen() == 0) {
		
		if ( GetPS2ElfName(fName) == TRUE ) 	LastLoadOK = TRUE;
		else LastLoadOK = FALSE;
				
	} else LastLoadOK = FALSE;

	

	return LastLoadOK;

}

// __________________________________________________________________________________________________
// BindModule
//
BOOL CALLBACK BindModule (SModuleBind* _pModuleBind)
{
	if (_pModuleBind != NULL)
	{
		switch(_pModuleBind->dwBindNumber)
		{
		case RPC_NPM_USER:	_pModuleBind->pCallFunction = sifcall_naplink;	break;
		case CDVD_IRX:		_pModuleBind->pCallFunction = sifcall_cdvd;		break;
		case SJPCM_IRX:		_pModuleBind->pCallFunction = sifcall_sjpcm;	break;
		case AMIGAMOD_IRX:	_pModuleBind->pCallFunction = sifcall_amigamod;	break;
//standard calls
		case 0x80000001:	_pModuleBind->pCallFunction = sifcall_fileio;	break;
		case 0x80000003:	_pModuleBind->pCallFunction = sifcall_sysmem;	break;
		case 0x80000400:	_pModuleBind->pCallFunction = sifcall_mcserv;	break;
		case 0x80000592:	_pModuleBind->pCallFunction = sifcall_cdvdfsv2;	break;
		case 0x80000593:	_pModuleBind->pCallFunction = sifcall_cdvdfsv3;	break;
		case 0x80000595:	_pModuleBind->pCallFunction = sifcall_cdvdfsv5;	break;
		case 0x80000596:	_pModuleBind->pCallFunction = sifcall_cdvdfsv6;	break;
		case 0x80000597:	_pModuleBind->pCallFunction = sifcall_cdvdfsv7;	break;
		case 0x8000059a:	_pModuleBind->pCallFunction = sifcall_cdvdfsvA;	break;
		case 0x80000601:	_pModuleBind->pCallFunction = sifcall_osdsnd;	break;

		// =====================================================================
		case 0x80000006:	_pModuleBind->pCallFunction = sifcall_module;	break;
		case 0x8000010f:	_pModuleBind->pCallFunction = sifcall_pad1;		break;
		case 0x8000011f:	_pModuleBind->pCallFunction = sifcall_pad2;		break;
		case 0x80000100:	_pModuleBind->pCallFunction = sifcall_xpad1;	break;
		case 0x80000101:	_pModuleBind->pCallFunction = sifcall_xpad2;	break;
		

		case 0x80000901:	_pModuleBind->pCallFunction = sifcall_mtapman1;	break;
		case 0x80000903:	_pModuleBind->pCallFunction = sifcall_mtapman3;	break;
		// ==========================================================================================
		// unknown bind number, cant HLE
		// ==========================================================================================
		default:
			SysPrintf("ERROR !!!: Unknown Service: 0x%x\n", _pModuleBind->dwBindNumber);
//			_BREAKPOINT_;
			_pModuleBind->pCallFunction = sifcall_fake;
			return false;
			break;
		}
	}

	return true;
}



static struct {
	char	*name;
	u32		size;
} ioprps[]={
	{"IOPRP15",    82741},
	{"IOPRP151",   82917},
	{"IOPRP153",   82949},
	{"IOPRP16",    91909},
	{"IOPRP165",   98901},
	{"IOPRP20",   109809},
	{"IOPRP202",  110993},
	{"IOPRP205",  119797},
	{"IOPRP21",   126857},
	{"IOPRP211",  129577},
	{"IOPRP213",  129577},
	{"IOPRP214",  140945},
	{"IOPRP22",   199257},
	{"IOPRP221",  196937},
	{"IOPRP222",  198233},
	{"IOPRP224",  201065},
	{"IOPRP23",   230329},
	{"IOPRP234",  247641},
	{"IOPRP24",   251065},
	{"IOPRP241",  251049},
	{"IOPRP242",  252409},
	{"IOPRP243",  253201},
	{"IOPRP252",  265233},
	{"IOPRP254",  264449},
	{"IOPRP255",  264449},
	{NULL,             0}
};


// __________________________________________________________________________________________________
// SetRPCVersion
//
void CALLBACK SetRPCVersion (char* _ioprp)
{
	char	*p=_ioprp; int i;
	struct TocEntry te;
	
	if (p && (CDVD_findfile(p+strlen("cdromN:"), &te) != -1)){
		for (i=0; ioprps[i].size>0; i++)
			if (te.fileSize==ioprps[i].size)
				break;
			if (ioprps[i].size>0)
				p=ioprps[i].name;
	}
	if (p && (p=strstr(p, "IOPRP")+strlen("IOPRP"))){
		for (i=0;(i<4) && p && (*p>='0') && (*p<='9');i++, p++)	RPCVER[i]=*p;
		for (   ; i<4								 ;i++     ) RPCVER[i]='0';
	}

	char dbg[5];
	memcpy(dbg, RPCVER, 4);
	dbg[4] = 0;
	SysPrintf("New RPC-Version %s\n", dbg);
//	strncpy((char*)&RPCVER, "1650", 4);
}



unsigned long CALLBACK GetElfAdd( void ) {


	return ElfStartAdress;


}