/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "PS2Edefs.h"



#define XPAD_RPCCMD_OPEN         0x01
#define XPAD_RPCCMD_SET_MMODE    0x06
#define XPAD_RPCCMD_SET_ACTDIR   0x07
#define XPAD_RPCCMD_SET_ACTALIGN 0x08
#define XPAD_RPCCMD_GET_BTNMASK  0x09
#define XPAD_RPCCMD_SET_BTNINFO  0x0A
#define XPAD_RPCCMD_SET_VREF     0x0B
#define XPAD_RPCCMD_GET_PORTMAX  0x0C
#define XPAD_RPCCMD_GET_SLOTMAX  0x0D
#define XPAD_RPCCMD_CLOSE        0x0E
#define XPAD_RPCCMD_END          0x0F
#define XPAD_RPCCMD_INIT         0x10
#define XPAD_RPCCMD_GET_CONNECT  0x11
#define XPAD_RPCCMD_GET_MODVER   0x12


#define InfoModeCurID		(1)
#define InfoModeCurExID		(2)
#define InfoModeCurExOffs	(3)
#define InfoModeIdTable		(4)


#define	PAD_INFO_TYPE_NEGI_COM 		2
#define	PAD_INFO_TYPE_KONAMI_GUN 	3
#define	PAD_INFO_TYPE_STANDARD  	4
#define	PAD_INFO_TYPE_JOY_STICK 	5
#define	PAD_INFO_TYPE_NAMCO_GUN 	6
#define	PAD_INFO_TYPE_ANALOG  		7
#define	PAD_INFO_TYPE_TSURI_CON 	0x100:
#define	PAD_INFO_TYPE_JOG_CON 		0x300:



/*
At Adress fBinaryInAddr, note: value(position)
: 80000100(0) 00000000(1) 00000000(2) 00000000(3)
: 003309c0(4) 00000000(5) 00000000(6) 00000000(7)



*/

void RPC_80000100_XPadMan1( _u32 fRPCcommand, _u64 fBinaryInAddr, _u64 fBinaryOutAddr ) {
	char temp_string[100];
	char * tempString;
int 	port;
	
	_u32 * RPC_Pad_Command;
	_u32 * RPC_Pad_Return;

	RPC_Pad_Command = (  _u32 * ) &MipsMemory [   fBinaryInAddr  & 0x01FFFFFF ];
	RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];


	if ( fRPCcommand != 1 ) return;




	switch (*RPC_Pad_Command) {
		case XPAD_RPCCMD_OPEN:

#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_XPAD1][PadCommand] OPEN");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif




			port =*( RPC_Pad_Command + 1 );

			*(RPC_Pad_Return + 3 ) = 1;		//Must not be 1

		Ps2Bios.XPadData[port][0] = (struct _XPad_Data * ) &MipsMemory [   ((_u32)*(RPC_Pad_Command + 4)) & 0x01FFFFFF ];
		Ps2Bios.XPadData[port][1] = (struct _XPad_Data * ) &MipsMemory [   ((_u32)*(RPC_Pad_Command + 4 + sizeof(struct _XPad_Data))) & 0x01FFFFFF ];
			

//			XPadArea[port][0] = (struct xpad_data*)PSM(*(unsigned long*)&bin[16/4]);
//			XPadArea[port][1] = (struct xpad_data*)PSM(*(unsigned long*)&bin[16/4] + sizeof(struct pad_data));
			Ps2Bios.XPadData[port][1]->frame = 0;
			Ps2Bios.XPadData[port][0]->frame = 0;
			Ps2Bios.XPadData[port][0]->state = PAD_STATE_STABLE;
			Ps2Bios.XPadData[port][0]->reqState = PAD_RSTAT_COMPLETE;
			Ps2Bios.XPadData[port][0]->length = sizeof(struct _padButtonStatus);
			Ps2Bios.PadState[port] = (struct _padButtonStatus*)Ps2Bios.XPadData[port][0]->data;
			Ps2Bios.PadState[port]->btns[0] = 0xff;
			Ps2Bios.PadState[port]->btns[1] = 0xff;
			break;

		case XPAD_RPCCMD_SET_MMODE:
#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_XPAD1][PadCommand] SET_MMODE");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif


			*(RPC_Pad_Return + 5 ) = 4;


			break;

		case XPAD_RPCCMD_GET_PORTMAX:
#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_XPAD1][PadCommand] GET_PORTMAX");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif

			*(RPC_Pad_Return + 3 ) = 2;
			break;

		case XPAD_RPCCMD_GET_SLOTMAX:

#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_XPAD1][PadCommand] GET_SLOTMAX");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif


			*(RPC_Pad_Return + 3 ) = 1;
//			bout[12/4] = 1;
			break;

		case XPAD_RPCCMD_GET_MODVER:

#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_XPAD1][PadCommand] GET_MODVER");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif



			//bout[12/4] = 0x300; // version??
			*(RPC_Pad_Return + 3 ) = 0x400;
//			Log=1;
			break;


		case XPAD_RPCCMD_INIT:
#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_XPAD1][PadCommand] INIT");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif


			*(RPC_Pad_Return + 3 ) = 0x1;

		break;


		default:

#ifdef EMU_LOG
	EMU_LOG("[RPC_XPAD1] command Unknow: 0x%8.8lx",*RPC_Pad_Command);
#endif

		break;

	}


}

