/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef _NSX2_TYPE_H
#define _NSX2_TYPE_H



typedef unsigned long long	_u64;
typedef unsigned long		_u32;
typedef unsigned short		_u16;
typedef unsigned char		_u8;

typedef	long long			_s64;
typedef	long				_s32;
typedef	short				_s16;
typedef	char				_s8;


/*
128 bits structure
*/
typedef struct __u128 {
	_u64 lo;
	_u64 hi;
} _u128;

/*
128 bits structure V2
*/

typedef struct __u8bit_128 {
		_u8	b00;
		_u8	b01;
		_u8	b02;
		_u8	b03;
		_u8	b04;
		_u8	b05;
		_u8	b06;
		_u8	b07;
		_u8	b08;
		_u8	b09;
		_u8	b10;
		_u8	b11;
		_u8	b12;
		_u8	b13;
		_u8	b14;
		_u8	b15;

}_u8bit_128;

typedef struct __u16bit_128 {
		_u16	h00;
		_u16	h01;
		_u16	h02;
		_u16	h03;
		_u16	h04;
		_u16 	h05;
		_u16	h06;
		_u16	h07;

}_u16bit_128;

typedef struct __u32bit_128 {
		_u32	w00;
		_u32	w01;
		_u32	w02;
		_u32	w03;

}_u32bit_128;


typedef struct _u128v2 {
	union {
		_u128 b128;
		_u8bit_128 b8;
		_u16bit_128 b16;
		_u32bit_128 b32;

	};

}u128v2;


#endif
