/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#ifndef _R5900_MAIN_H
#define _R5900_MAIN_H

//From Hacktarux
#define sign_extended(a) if (a & 0x0000000080000000LL) a |= 0xFFFFFFFF00000000LL; else a &= 0xFFFFFFFF
#define sign_extendedb(a) if (a & 0x80) a |= 0xFFFFFFFFFFFFFF00LL; else a &= 0xFF
#define sign_extendedh(a) if (a & 0x8000) a |= 0xFFFFFFFFFFFF0000LL; else a &= 0xFFFF




// Increment the PC 
#define INCREMENT_PC() MipsCpu.PC = MipsCpu.PC + 4
 
// Read the Memory at PC value
#define MipsFillOpcode(A) MipsCpu.opcode=*( (_u64 *) (( _u8 *)( MipsMemory + ( A & 0x01FFFFFF)) ))

// Ease the code
#define		_OPCODE_				MipsCpu.opcode
#define		_VU_OPCODE_				MipsCpu.vuOpcode

//This macro decode the memory and Fill the opcode field of the cpu
#define		CURRENT_RT				( ( (_u32)MipsCpu.opcode >> 16 )  & (_u32)0x0000001F )
#define		CURRENT_RS				( ( (_u32)MipsCpu.opcode >> 21 )  & (_u32)0x0000001F )
#define		CURRENT_RD				( ( (_u32)MipsCpu.opcode >> 11 )  & (_u32)0x0000001F )
#define		CURRENT_BASE			( ( (_u32)MipsCpu.opcode >> 21 )  & (_u32)0x0000001F )
#define		CURRENT_SA				( ( (_u32)MipsCpu.opcode >> 6  )  & (_u32)0x0000001F )
#define		CURRENT_IMM				(((_OPCODE_)& 0xFFFF))
#define		CURRENT_OFFSET			(((_OPCODE_)& 0xFFFF))
#define		CURRENT_INSTR_INDEX		(((_OPCODE_)& 0x3FFFFFF))
#define		CURRENT_SEL				(((_OPCODE_)& 0x7))

#define		CURRENT_FT				( ( (_u32)MipsCpu.opcode >> 16 )  & (_u32)0x0000001F )
#define		CURRENT_FD				( ( (_u32)MipsCpu.opcode >> 6  )  & (_u32)0x0000001F )
#define		CURRENT_FS				( ( (_u32)MipsCpu.opcode >> 11 )  & (_u32)0x0000001F )



#define		CURRENT_CC				(((_OPCODE_)& 0x700)>>8)
#define		CURRENT_CCB				(((_OPCODE_)& 0x1C0000)>>18)


#define		CURRENT_ID				( ( (_u32)MipsCpu.opcode >> 11 )  & (_u32)0x0000001F )



#define		CURRENT_VU_FT				(((_VU_OPCODE_)& 0x1F0000)>>16)
#define		CURRENT_VU_FD				(((_VU_OPCODE_)& 0x7C0)>>6)
#define		CURRENT_VU_FS				(((_VU_OPCODE_)& 0xF800)>>11)

#define		CURRENT_VU_FSF				(((_VU_OPCODE_) >> 21) & 0x3 )
#define		CURRENT_VU_FTF				(((_VU_OPCODE_) >> 23) & 0x3 )
#define		CURRENT_VU_BC				(((_VU_OPCODE_) & 0x3))
#define		CURRENT_VU_DEST				(((_VU_OPCODE_) >> 21) & 0xF)

#define		CURRENT_VU_IT				(((_VU_OPCODE_)& 0x1F0000)>>16)
#define		CURRENT_VU_IS				(((_VU_OPCODE_)& 0xF800)>>11)
#define		CURRENT_VU_ID				(((_VU_OPCODE_)& 0x7C0)>>6)			//TAKE CARE OF CURRENT_ID

char debugTempText[100];
char debugTempOpcodeText[100];


/*
Macro to extract the field of the Opcode
*/
#define Extractrt() 			CURRENT_RT	
#define Extractrs() 			CUURENT_RS
#define Extractbase() 			CURRENT_BASE	
#define Extractimm() 			CURRENT_IMM
#define Extractoffset() 		CURRENT_OFFSET
#define Extractrd() 			CURRENT_RD	
#define Extractinstr_index() 	CURRENT_INSTR_INDEX
#define Extractsa() 			CURRENT_SA	
#define Extractsel() 			CURRENT_SEL	

#define Extractft() 			CURRENT_FT	
#define Extractfd() 			CURRENT_FD	
#define Extractfs() 			CURRENT_FS
#define Extractcc() 			CURRENT_CC
#define Extractccb() 			CURRENT_CCB


#define Extractid() 			CURRENT_ID
#define ExtractCop2fsf()		CURRENT_FSF
#define ExtractCop2ftf()		CURRENT_FTF

#define ExtractCop2bc()			CURRENT_BC

#define ExtractCop2dest()		CURRENT_DEST


_u8 IsSignExtended( _u64 fval );
_u8 IsNot32bitIntegerOverflow ( _u64  fval);
_u8 IsNot64bitIntegerOverflow ( _u64  fval);


//#define	R5900_OP_LOG	R5900_OP_Log
#undef	R5900_OP_LOG

void R5900_OP_Log ( char * ftext  , ...   );

/* new version */
#define		CalculTargetBranch	target_branch = MipsCpu.PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 )


void R5900_Core_init    ( void );
void R5900_Cop1_init    ( void );
void R5900_Cop0_init    ( void );






#endif

